/**
 * Header for library implemented in Scheme.
 */
#ifndef _cfoo_h_
#define _cfoo_h_

/**
 * Compilation flag determining whether the library will be linked
 * dynamically or statically. Dynamic linkage is the default.
 */
#ifndef CFOO_SHARED
#define CFOO_SHARED 1
#endif

/**
 * Setup a macro for proper export declarations for either dynamic or
 * static linkage under different operating systems.
 */
#if CFOO_SHARED
#	if defined(_WIN32) || defined(_MSC_VER) || \
	   defined(__CYGWIN) || defined(__MINGW32__)
#		if defined(_CFOO_IMPL_)
#			define CFOO_EXPORT extern __declspec(dllexport)
#		else
#			define CFOO_EXPORT extern __declspec(dllimport)
#		endif
#	else
#		define CFOO_EXPORT extern
#	endif
#else
#	define CFOO_EXPORT extern
#endif

#ifdef __cplusplus
extern "C" {
#endif

/**
 * A scheme function to call.
 */
CFOO_EXPORT void cfoo_say_hello(char *name);

#ifdef __cplusplus
}
#endif

#endif /* _cfoo_h_ */
